#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   This file is part of IntiPunku
#   Copyright (C) 2007 Mark Baas <mark.baas123@gmail.com>
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Affero General Public License as
#   published by the Free Software Foundation, either version 3 of the
#   License, or (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.

# These are overrides to improve OSX integration with pygtk

from gtk._gtk import *
import gobject
import os.path
import EasyDialogs


class FileChooserButton(Button):
    __gsignals__ = {
        'changed' : (gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, ()),
        }
    def __init__(self, title="Select a folder"):
        Button.__init__(self)
        self.title = title
        self.filename = os.path.expanduser("~")
        hbox = HBox()
        self.add(hbox)
        hbox.pack_start(image_new_from_icon_name("folder", 24), fill=False, expand=False)
        self.label = Label(title)
        hbox.pack_start(self.label)
        
        self.connect("show", self.show_cb)
        self.connect("clicked", self.clicked_cb)
        
    def show_cb(self, *args):
        print self.get_allocation().width
     
    def clicked_cb(self, widget):
        filename = EasyDialogs.AskFolder(
            message=self.title,
            defaultLocation=self.filename,
            wanted=unicode,
            )
        self.filename = filename
        self.set_label(self.filename)
        self.emit("changed")
        
    def set_current_folder(self, path):
        self.set_label(path)
        self.filename = path
        
    def get_filename(self):
        return self.filename
        
    def set_action(self, *args):
        pass
        
    def set_label(self, label):
        self.label.set_text(label)
        
    def get_children(self):
        return [None, self]